package ru.dbotthepony.kstarbound.lua

import org.classdump.luna.ByteString
import org.classdump.luna.LuaRuntimeException
import org.classdump.luna.impl.NonsuspendableFunctionException
import org.classdump.luna.runtime.AbstractFunction1
import org.classdump.luna.runtime.ExecutionContext
import ru.dbotthepony.kstarbound.Starbound

class LuaRequire(private val state: NewLuaState) : AbstractFunction1<ByteString>() {
	override fun resume(context: ExecutionContext?, suspendedState: Any?) {
		throw NonsuspendableFunctionException(this::class.java)
	}

	override fun invoke(context: ExecutionContext, arg1: ByteString) {
		val name = arg1.decode()

		val file = Starbound.locate(name)

		if (!file.exists) {
			throw LuaRuntimeException("File $name does not exist")
		}

		if (!file.isFile) {
			throw LuaRuntimeException("File $name is a directory")
		}

		state.load(context, file.readToString(), file.computeFullPath())
	}
}
