package ru.dbotthepony.kstarbound.world.api

import ru.dbotthepony.kommons.util.IStruct2i
import ru.dbotthepony.kommons.vector.Vector2i

interface ICellAccess {
	/**
	 * with wrap-around
	 */
	fun getCell(x: Int, y: Int): AbstractCell
	fun getCell(pos: IStruct2i) = getCell(pos.component1(), pos.component2())

	/**
	 * without wrap-around
	 */
	fun getCellDirect(x: Int, y: Int): AbstractCell
	fun getCellDirect(pos: IStruct2i) = getCellDirect(pos.component1(), pos.component2())

	/**
	 * whenever cell was set
	 */
	fun setCell(x: Int, y: Int, cell: AbstractCell): Boolean
}

