package ru.dbotthepony.kstarbound.world.entities

import com.google.gson.JsonObject
import ru.dbotthepony.kommons.vector.Vector2d
import ru.dbotthepony.kommons.vector.Vector2i
import ru.dbotthepony.kstarbound.world.ChunkPos
import ru.dbotthepony.kstarbound.world.SpatialIndex
import ru.dbotthepony.kstarbound.world.World

/**
 * (Hopefully) Static world entities (Plants, Objects, etc), which reside on cell grid
 */
abstract class TileEntity(path: String) : AbstractEntity(path) {
	var tilePosition = Vector2i()
		set(value) {
			if (isSpawned) {
				field = world.geometry.wrap(value)
				// spatialEntry?.fixture?.move()
			} else {
				field = value
			}
		}

	override val position: Vector2d
		get() = tilePosition.toDoubleVector()

	override fun onJoinWorld(world: World<*, *>) {
		tilePosition = tilePosition
	}

	override fun onRemove(world: World<*, *>) {
	}
}
